
VAR
  Write_String : String[50];
  Zeichen : Byte;


// ***********************************************
// *****    Bit-Manipulations-Programme      *****
// ***********************************************



function BytePosToORMaske(BytePos : Byte) : Byte;
begin
  case BytePos of
    0 : RESULT:=%00000001;
    |
    1 : RESULT:=%00000010;
    |
    2 : RESULT:=%00000100;
    |
    3 : RESULT:=%00001000;
    |
    4 : RESULT:=%00010000;
    |
    5 : RESULT:=%00100000;
    |
    6 : RESULT:=%01000000;
    |
    7 : RESULT:=%10000000;
    |
  else
    RESULT:=%00000001;
  endcase;

end BytePosToORMaske;





function BytePosToANDMaske(BytePos : Byte) : Byte;
begin
  case BytePos of
    0 : RESULT:=%11111110;
    |
    1 : RESULT:=%11111101;
    |
    2 : RESULT:=%11111011;
    |
    3 : RESULT:=%11110111;
    |
    4 : RESULT:=%11101111;
    |
    5 : RESULT:=%11011111;
    |
    6 : RESULT:=%10111111;
    |
    7 : RESULT:=%01111111;
    |
  else
    RESULT:=%11111110;
  endcase;

end BytePosToANDMaske;




function Read_Bit_in_Byte(TestByte, BytePos : Byte) : Boolean;
var
  Vergleich : Byte;
  Maske : Byte;
begin

  Maske:=BytePosToORMaske(BytePos);

  Vergleich:=TestByte and Maske;

  if Vergleich=0 then
    RESULT:=false;
  else
    RESULT:=true;
  endif;

end  Read_Bit_in_Byte;











function Set_Bit_in_Byte(TestByte, BytePos : Byte) : Byte;
var
  Ergebnis : Byte;
  Maske : Byte;
begin

  Maske:=BytePosToORMaske(BytePos);

  Ergebnis:=TestByte or Maske;

  RESULT:=Ergebnis;

end  Set_Bit_in_Byte;







function Clear_Bit_in_Byte(TestByte, BytePos : Byte) : Byte;
var
  Ergebnis : Byte;
  Maske : Byte;
begin

  Maske:=BytePosToANDMaske(BytePos);

  Ergebnis:=TestByte AND Maske;

  RESULT:=Ergebnis;

end  Clear_Bit_in_Byte;







// ******************************
// ***    Hilfssprogramme     ***
// ******************************




PROCEDURE wait_ms(Zeit : Word);
VAR
  w1 : Word;
  w2 : Word;
BEGIN
  for w1:=1 to Zeit do
    for w2:=1 to 900 do // 45 * MHz
    endfor;
  endfor;
END wait_ms;








// ******************************
// *** serielle Schnittstelle ***
// ******************************



procedure INIT_SER_PORT;
begin

{
 Initialisieren der seriellen Schnittstelle
 ---------------------------------------------

; festlegen der Baudrate fuer die serielle Schnittstelle
}

    UBRR0 := UBRR_VAL;

{
Bit 4 – RXEN: Receiver Enable
Bit 3 – TXEN: Transmitter Enable
}
    UCSR0B := %00011000;

{
URSEL UMSEL UPM1 UPM0 USBS UCSZ1 UCSZ0 UCPOL
    1     0    0    0    0     1     1     0
}
    UCSR0C := %10000110;


end INIT_SER_PORT;





procedure RX_Puffer_abfragen;
begin
  // wurde ein Byte durch die UART empfangen, so ist das RXC0-Bit gesetzt
  // ist RXC0-Bit = 0, dann ist der Empfangs-Puffer leer
  if BitHigh(RXC0) then
    Zeichen:=UDR0;
  else
    Zeichen:=0;
  endif; { if BitHigh(RXC0) then }
end RX_Puffer_abfragen;





procedure sende_Zeichen(s_Zeichen : Byte);
begin
  // wenn UDRE0 gesetzt ist, so ist der Puffer leer
  // -> warten solange UDRE0 = 0
  while BitLow(UDRE0) do
  //  SetBit(LED_GRUEN); // gruen ein
  endwhile;

//  ClearBit(LED_GRUEN); // gruen aus

  UDR0:=s_Zeichen;

end sende_Zeichen;



procedure sende_HEX_Zeichen(h_Zeichen : Byte);
var
  HexLow : Byte;
  HexHigh : Byte;
begin

  HexHigh:=h_Zeichen and $F0;
  SHR(HexHigh);
  SHR(HexHigh);
  SHR(HexHigh);
  SHR(HexHigh);
  if HexHigh>9 then
    HexHigh:=HexHigh+55;
  else
    HexHigh:=HexHigh+48;
  endif;

  sende_Zeichen(HexHigh);

  HexLow:=h_Zeichen and $0F;
  if HexLow>9 then
    HexLow:=HexLow+55;
  else
    HexLow:=HexLow+48;
  endif;

  sende_Zeichen(HexLow);

  sende_Zeichen($48); // H

end sende_HEX_Zeichen;



procedure sende_HEX_Zeichen_Ln(Wert_Byte : Byte);
begin
  sende_HEX_Zeichen(Wert_Byte);
  sende_Zeichen($0D); // CR
  sende_Zeichen($0A); // LF
end sende_HEX_Zeichen_Ln;






procedure Write;
var
  c1 : Char;
  Laenge : Byte;
  b1 : Byte;
  b2 : Byte;
begin

  Laenge:=Length(Write_String);
  for b1:=1 to Laenge do
    c1:=Write_String[b1];
    b2:=CharToByte(c1);
    sende_Zeichen(b2);
  endfor;

end Write;




procedure WriteLn;
begin
  Write;
  sende_Zeichen($0D); // CR
  sende_Zeichen($0A); // LF
end WriteLn;





procedure ByteToString(Wert_Byte : Byte);
var
  HexLow : Byte;
  HexHigh : Byte;
  c1 : Char;
begin

  HexHigh:=Wert_Byte and $F0;
  SHR(HexHigh);
  SHR(HexHigh);
  SHR(HexHigh);
  SHR(HexHigh);
  if HexHigh>9 then
    HexHigh:=HexHigh+55;
  else
    HexHigh:=HexHigh+48;
  endif;

  c1:=ByteToChar(HexHigh);
  Write_String:=c1;

  HexLow:=Wert_Byte and $0F;
  if HexLow>9 then
    HexLow:=HexLow+55;
  else
    HexLow:=HexLow+48;
  endif;

  c1:=ByteToChar(HexLow);
  Write_String:=Write_String+c1;

end ByteToString;







function StringToByte : Byte;
var
  HexLow : Byte;
  HexHigh : Byte;
  S2B : Byte;
  c1 : Char;
begin

  c1:=Write_String[1];
  HexHigh:=CharToByte(c1);
  HexHigh:=HexHigh-48;
  if HexHigh>9 then
    HexHigh:=HexHigh-7;
  endif;
  SHL(HexHigh);
  SHL(HexHigh);
  SHL(HexHigh);
  SHL(HexHigh);

  c1:=Write_String[2];
  HexLow:=CharToByte(c1);
  HexLow:=HexLow-48;
  if HexLow>9 then
    HexLow:=HexLow-7;
  endif;

  S2B:=HexHigh+HexLow;

  RESULT:=S2B;

end StringToByte;



